#!/usr/bin/awk -f 
# written by Christoph Mitterhofer
# xml2-alike in awk
BEGIN{
  RS="<";
  XPATH="/";
  depth = 0
  XLIST[0]=""
}
# $0 is either a starting or an ending tag
function tagline() { 
 pstr = ""; 
 for (i=1; i<=depth;i++) {pstr=pstr "/" XLIST[i];}
 return pstr; 
}
function printattr(prefix, fcount, arr,      i, fields, attname, attval) { 
  # arr is: "attname=\"attval" "attname=\"attval""

  for (i in arr) { 
    l = arr[i]; 
    gsub(/=\"/, "=", l ) 
    gsub(/\"$/, "", l ) 
    print prefix l 
  }
}
{ 
  gsub(/>[\n ]*$/, ">")
  # print "DEBUG: '" $0 "'"
  if ($1=="?xml" ) { 
    # ignore silently
  } else if ( $1 ~ /!--/ ) { 
    # Comments are printed
    print $0 ; 
  } else if ($1~/^\//) { 
    # end tag
    tag=$1
    gsub(/^\//, "", tag)
    gsub(/> *$/, "", tag)
    otag = XLIST[depth]
    if (tag != otag) { 
      print "Expected </" otag ">, got '" tag "'"
      exit(1)
    }
    depth--; 
  } else if ($1~/^[a-zA-Z0-9:]/) { 
    # start or empty tag
    emptytag = 0
    tag = $1
    gsub(/\/*>.*/, "", tag)
    if ($0~/\/>$/) {
      emptytag = 1;
    }
    depth++; 
    XLIST[depth] = tag
    if (emptytag == 0) { 
      print tagline();
    }
    # Get attributes
    content = $0
    $1 = ""
    attribs = $0
    gsub(/[a-z:0-9]*\/*>.*/, "", attribs)
    gsub(/^ */, "", attribs)

    # print "CONTENT='" $0 "'"
    gsub(/^[^>]*>/, "", content)
    # print "OOOOOCONTENT='" content "'"
    if (attribs != "") {
      fields = split(attribs, att, "\" ")
      prefix = tagline() "/@"; 
      printattr(prefix, fields, att); 
    }
    if (content != "") {
      gsub(" *\n", " ", content); 
      print tagline() "=" content;
    }
    if (emptytag == 1) { depth--; }
  } else if ($0 == "") { ; 
  } else { 
    print "Garbage: " $0; 
    exit(1)
  }
}
